#include <windows.h>
#include <stdio.h>
#include <stdlib.h>

HANDLE ghMutex;

unsigned long WINAPI fonc1(void* params)
{
	while(1)
	{
		//WaitForSingleObject(ghMutex,INFINITE);
		printf("message du thread ");
		Sleep(1);
		printf("numero 1\n");
		//ReleaseMutex(ghMutex);
	}
	return 0;
}

unsigned long WINAPI fonc2(void* params)
{
	while(1)
	{
		//WaitForSingleObject(ghMutex,INFINITE);
		printf("message du thread ");
		Sleep(1);
		printf("numero 2\n");
		//ReleaseMutex(ghMutex);
	}
	return 0;
}

int main()
{
	HANDLE h1;
	HANDLE h2;
	ghMutex = CreateMutex(NULL,FALSE,NULL);
	h1=CreateThread(NULL,0,fonc1,NULL,0,0);
	h2=CreateThread(NULL,0,fonc2,NULL,0,0);
	getchar();
	CloseHandle(h1);
	CloseHandle(h2);
	CloseHandle(ghMutex);
	return 0;
}

/*!F
	Reprenons le premier code sur les CreateThread.
	Je cre 2 threads, chacun va juste afficher un message.

	Pour l'instant, ignorez les lignes commentes. Vous pouvez constater que je fais le printf des threads en 2 fois, avec un Sleep(1)
	au milieu (attente de 1 millime de secondes). Je fais a pour accentuer la probabilit de mettre en vidence ce que je veux.

	Si vous lancez le programme dans l'tat, vous vous attendez  une suite de messages bien aligns comme a :

	message du thread numero 2
	message du thread numero 1
	message du thread numero 2
	message du thread numero 1
	message du thread numero 1
	message du thread numero 2
	message du thread numero 2

	Mais si vous regardez bien, un moment, vous allez tomber sur des trucs comme a :

	message du thread numero 1
	message du thread numero 1
	numero 2
	message du thread message du
	message du thread numero 2
	message du thread numero 2
	message du thread numero 1

	Que s'est il pass ?
	Et bien il faut savoir que Windows (et pareil pour n'importe quel OS) peut couper un thread n'importe quand pour donner la main  un autre.

	N'importe quand !

	Ici, en l'occurence, il a coup le thread entre les deux printf (pendant le Sleep). 
	Notez qu'il aurait trs bien couper en plein milieu du printf s'il n'y avait eu qu'un seul printf. a peut vraiment tre n'importe quand.

	Cela peut tre embtant. Parfois, on souhaiterait qu'un thread finisse ce qu'il est en train de faire avant que d'autres puissent tre appels.
	En l'occurence ici, on voudrait qu'un thread finisse d'crire sa ligne, avant que l'autre prenne le relai. Interdire de couper avant la fin
	de la ligne.

	Pour a, nous dfinissons ce qu'on appelle un Mutex.
	Un Mutex, pour faire simple, c'est jeton commun  tout le monde.

	Les threads sont des joueurs. Et il n'y a qu'un seul jeton.
	Quand un joueur prend le jeton, il peut travailler. Quand il a fini, il remet le jeton au centre de la table, et un autre peut alors le 
	prendre et travailler.
	Tant qu'un thread n'a pas le jeton, il l'attend. Il guette son retour sur la table pour le prendre  son tour.

	Voila donc l'ide du mutex.

	Dcommentez les lignes commentes dans le code, et constatez que plus jamais on a de phrases entremles comme vu au dessus.

	Dans le code, j'ai cr un mutex en global. Mais j'aurais trs bien pu crer une structure de donnes, comme vu au chapitre prcdent, et donner 
	un pointeur vers le mme mutex pour chaque thread.

	Le mutex s'appelle ghMutex. Je le cre avant de lancer les threads.

	http://msdn.microsoft.com/en-us/library/windows/desktop/ms682411(v=vs.85).aspx

	Puis, dans mes threads, je mets la ligne :

	WaitForSingleObject(ghMutex,INFINITE);

	qui veut dire que le thread attend le Mutex (le jeton). INFINITE veut dire qu'il pourra l'attendre indfiniment s'il le faut.

	Le thread ne passera cette ligne que si le jeton est libre, et il le prend. Aprs cette ligne, c'est lui et lui seul qui a le jeton.

	Ensuite, il fera ses printf. Et  la fin, on rend le jeton avec ReleaseMutex.
	Il est important de rendre le jeton, sinon, vous coincez tout le monde !

    ************** Danger de Deadlock **************

	La programmation multithread avec mutex peut crer des ennuis si vous n'tes pas bien rigoureux dans votre gestion des mutex.

	Imaginez que vous ayez 3 threads , A, B et C.

	Si A attend que B ait fini, que B attend que C ait fini, et que C attend que A ait fini, vous tes en deadlock :
	c'est  dire que plus personne ne bougera, le verouillage de la mort...

	Soyez bien rigoureux la dessus.
!*/

/*!E
	No explanations yet.
!*/

/*
titre: Utilisation des mutex.
titreE: Using Mutex.
meta: C;WINAPI;Windows;thread;mutex
metaE: C;WINAPI;Windows;thread;mutex
desc : Utilisation des mutex
descE : Using Mutex
cle  : CreateMutex
*/
